// This file is generated by kconfig_compiler from gstconfig.kcfg.
// All changes you do to this file will be lost.
#ifndef GSTCONFIG_H
#define GSTCONFIG_H

#include <kconfigskeleton.h>
#include <kdebug.h>

class GstConfig : public KConfigSkeleton
{
  public:

    static GstConfig *self();
    ~GstConfig();

    /**
      Set Sound output method to use
    */
    static
    void setSoundOutput( const QString & v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "SoundOutput" ) ))
        self()->mSoundOutput = v;
    }

    /**
      Get Sound output method to use
    */
    static
    QString soundOutput()
    {
      return self()->mSoundOutput;
    }

    /**
      Set Do not use the autodetected audiosink sound device
    */
    static
    void setUseCustomSoundDevice( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "UseCustomSoundDevice" ) ))
        self()->mUseCustomSoundDevice = v;
    }

    /**
      Get Do not use the autodetected audiosink sound device
    */
    static
    bool useCustomSoundDevice()
    {
      return self()->mUseCustomSoundDevice;
    }

    /**
      Set Sound output device to use
    */
    static
    void setSoundDevice( const QString & v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "SoundDevice" ) ))
        self()->mSoundDevice = v;
    }

    /**
      Get Sound output device to use
    */
    static
    QString soundDevice()
    {
      return self()->mSoundDevice;
    }

    /**
      Set Use custom parameters for output sink.
    */
    static
    void setUseCustomOutputParams( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "UseCustomOutputParams" ) ))
        self()->mUseCustomOutputParams = v;
    }

    /**
      Get Use custom parameters for output sink.
    */
    static
    bool useCustomOutputParams()
    {
      return self()->mUseCustomOutputParams;
    }

    /**
      Set The custom sink parameters.
    */
    static
    void setOutputParams( const QString & v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "OutputParams" ) ))
        self()->mOutputParams = v;
    }

    /**
      Get The custom sink parameters.
    */
    static
    QString outputParams()
    {
      return self()->mOutputParams;
    }

    /**
      Set Duration of Fade-out at trackend
    */
    static
    void setFadeoutDuration( int v )
    {
      if (v < 0)
      {
        kdDebug() << "setFadeoutDuration: value " << v << " is less than the minimum value of 0" << endl;
        v = 0;
      }

      if (v > 10000)
      {
        kdDebug() << "setFadeoutDuration: value " << v << " is greater than the maximum value of 10000" << endl;
        v = 10000;
      }

      if (!self()->isImmutable( QString::fromLatin1( "FadeoutDuration" ) ))
        self()->mFadeoutDuration = v;
    }

    /**
      Get Duration of Fade-out at trackend
    */
    static
    int fadeoutDuration()
    {
      return self()->mFadeoutDuration;
    }

    static
    void writeConfig()
    {
      static_cast<KConfigSkeleton*>(self())->writeConfig();
    }
  protected:
    GstConfig();
    static GstConfig *mSelf;


    // Gst-Engine
    QString mSoundOutput;
    bool mUseCustomSoundDevice;
    QString mSoundDevice;
    bool mUseCustomOutputParams;
    QString mOutputParams;
    int mFadeoutDuration;

  private:
};

#endif

